<?php
/*
 * -----------------------------------------
 * Das Script kann unter Verwendung dieses Vermerks uneingeschr&auml;nkt
 * genutzt / ver&auml;ndert werden.  www.bildergalerie-script.de
 * -----------------------------------------
 * Bildergalerie Script Version 2.51 - 20.06.2014
 * -----------------------------------------
 * @author 	Nico Schubert (info@schubertmedia.de)
 * @copyright 	Copyright 2011 - 2014
 * @version 	2.51 (PHP5)
 * -----------------------------------------
 */
class image_upload{
	/**
	 * @var array
	 * @access public
	 */
	public $alowfile=array();
	/**
	 * @var string
	 * @access public
	 */
	public $pfad;
	/**
	 * @var string
	 * @access public
	 */
	public $files;
	/**
	 * @var string
	 * @access private
	 */
	private $fehler;
	/**
	 * @var number
	 * @access private
	 */
	private $maxsize = 1073741824;
	/**
	 * @var string
	 * @access private
	 */
	private $url = '';
	/**
	 * @var string
	 * @access private
	 */
	private $beschreibung;
	/**
	 * @param string $alowfile
	 */
	function set_typforupload($alowfile){
		if(is_array($alowfile)==true)
			$this->alowfile=$alowfile;
		else
			$this->alowfile=array();
	}
	/**
	 * @return boolean
	 */
	function check_upload(){
		$check_upload=true;
		if(strtolower(@ini_get('file_uploads'))=='off' || @ini_get('file_uploads')==0){
			$check_uploadt=false;
		}
		return $check_upload;
	}
	/**
	 * @param string $url
	 * @return boolean or ''
	 */
	function seturl($url) {
		if($url!='')
			$this->url = $url;
		else {
			return false;
		}
	}
	/**
	 * @param string $pfad
	 * @return boolean or ''
	 */
	function setpfad($pfad) {
		if($pfad!='')
			$this->pfad = $pfad;
		else {
			return false;
		}
	}
	/**
	 * @param string $newdir
	 * @return boolean or ''
	 */
	function setnewdir($newdir) {
		if($newdir!='')
			$this->newdir = $newdir;
		else {
			return false;
		}
	}
	/**
	 * @param string $olddir
	 * @return boolean or ''
	 */
	function setolddir($olddir) {
		if($olddir!='')
			$this->olddir = $olddir;
		else {
			return false;
		}
	}
	/**
	 * @param string $rmdir_dir
	 * @return boolean or ''
	 */
	function setrmdir_dir($rmdir_dir) {
		if($rmdir_dir!='')
			$this->rmdir_dir = $rmdir_dir;
		else {
			return false;
		}
	}
	/**
	 * @param number $kategorie_id
	 * @return boolean or ''
	 */
	function setkategorie_id($kategorie_id) {
		if($kategorie_id!='')
			$this->kategorie_id = $kategorie_id;
		else {
			return false;
		}
	}
	/**
	 * @param array $kategorie
	 * @return boolean
	 */
	function setkategorie ($kategorie) {
		if(is_array($kategorie)==true AND count($kategorie)!=0)
			$this->kategorie = $kategorie;
		else {
			return false;
		}
	}
	/**
	 * @param string $beschreibung
	 * @return boolean
	 */
	function setbeschreibung($beschreibung) {
		if($beschreibung!='')
			$this->beschreibung = $beschreibung;
		else {
			return false;
		}
	}
	/**
	 * @param number $maxsize
	 * @return boolean
	 */
	private function setmaxsize($maxsize) {
		if($maxsize!='')
			$this->maxsize = $maxsize;
		else {
			return false;
		}
	}
	/**
	 * Die Funtion get_beschreibung($filename); erstellt aus dem Datenname die Beschreibung und gibt diese als String zurck
	 * @param string $filename - Pfad zum Bild mit Datename und Dateiendung
	 * @return string
	 */
	public function get_beschreibung($filename=''){
		if($filename=='') return '';
		$info = pathinfo($filename);
		$filename_orginal=basename($filename);
		$beschreibung=ucfirst(basename($filename,'.'.$info['extension']));
		return $beschreibung;
	}

	/**
	 * Gib ein Array zurck mit width, height, type und attr. Wenn es die Datei nicht gibt, wird ein False zurck gegeben
	 * @param string $filename
	 * @return boolean|multitype:array
	 */
	public function get_imagesize($filename=''){
		if($filename=='') return false;
		if(!file_exists($filename)) return false;
		list($width, $height, $type, $attr) = @getimagesize($filename);
		return array('width' => $width, 'height' => $height, 'type' => $type, 'attr' => $attr);
	}
	/**
	 * @return boolean|string
	 */
	function view_kategorie(){
		if($this->kategorie==false) return false;
		$ausgabe='<select name="kategorie">';
		foreach($this->kategorie as $k => $v ){
			$ausgabe.='<option value="'.$k.'" '.(($this->kategorie_id==$k)? 'selected':'').'>'.$v.'</option>';
		}
		$ausgabe.='</select>';
	    return $ausgabe;
	}
	/**
	 * @return number
	 */
	private function max_upload(){
		$max_upload = 0;
	    if($dateigroesse = @ini_get('upload_max_filesize')){
	        $max_upload = $this->phpiniwertumwandeln($dateigroesse);
	    }
	    if($postgroesse = @ini_get('post_max_size')){
	        $postgroesse = $this->phpiniwertumwandeln($postgroesse);
	        if($postgroesse < $max_upload){
	            $max_upload = $postgroesse;
	        }
	    }
	    if( $max_upload > $this->maxsize )
	    	$max_upload=$this->maxsize;
	    return $max_upload;
	}
	/**
	 * @param number $size
	 * @param number $nachkommastellen
	 * @return string
	 */
	private function size_convert ($size, $nachkommastellen = 0) {
		switch ($size) {
        	case ($size >='1073741824'):
        		return round($size/(1073741824), $nachkommastellen)." GB";
        	break;
        	case ($size >='1048576'):
        		return round($size/(1048576), $nachkommastellen)." MB";
        	break;
        	case ($size >='1024'):
        		return round($size/(1024), $nachkommastellen)." KB";
        	break;
        	default:
        		return $size." Byte";
        	break;
        }
	}
	/**
	 * @param number $groesse
	 * @return number
	 */
	private function phpiniwertumwandeln($groesse){
		$werte['MB'] = 1048576;
		$werte['Mb'] = 1048576;
		$werte['M'] = 1048576;
		$werte['m'] = 1048576;
		$werte['KB'] = 1024;
		$werte['Kb'] = 1024;
		$werte['K'] = 1024;
		$werte['k'] = 1024;
		while(list($schluessel)=each($werte)){
			if((strlen($groesse)>strlen($schluessel)) && (substr($groesse, strlen($groesse)-strlen($schluessel))==$schluessel))		{
				$groesse=substr($groesse, 0, strlen($groesse)-strlen($schluessel))*$werte[$schluessel];
				break;
			}
		}
		return $groesse;
	}
	/**
	 * @return boolean
	 */
	function imageupload(){
	  $verzeichnis = realpath($this->pfad);
	  if(is_dir($verzeichnis) && is_writeable($verzeichnis)){
		  $this->pfad = $verzeichnis."/";
	  } else {
	  	$this->error(0, "Bitte bearbeiten Sie die config.php ");
	  	return false;
	  }
	}
	/**
	 * @param number $key
	 * @param string $details
	 */
	function error($key,$details=""){
	 	$mess[] = "Es fehlt ein Tempverzeichnis!";
	    $mess[] = "Die Datei ist zu gro&szlig;!";
	    $mess[] = "Falscher Dateityp";
	    $mess[] = "Falsche Schreibrechte";
	    $mess[] = "Die Datei gibt es schon in dieser Kategorie. ";
	    $mess[] = "Der Ordner f&uuml;r die Kategorie gibt es nicht. ";
		$this->fehler="Fehler: " . $mess[$key] . "<br>". $details;
	}

	/**
	 * Gibt die Fehlermeldung zurck
	 * @return string
	 */
	function get_error(){
		if(isset($this->fehler))
			return $this->fehler;
		else
			return '';
	}
	/**
	 * @return string
	 */
	function upload_max_filesize(){
		$upload_max_filesize=$this->max_upload();
		return $this->size_convert($upload_max_filesize);
	}
	/**
	 * @return string
	 */
	function _htmlpostfile(){
		$ausgabe='';
		$kategorie=$this->view_kategorie();
		if($kategorie==false){
			$ausgabe='Bitte tragen Sie eine Kategorie ein!';
		} else {
			$upload_max_filesize=$this->max_upload();
			$ausgabe .= '<p><form action="' . $this->url . '?'.SID.'" method="post" enctype="multipart/form-data" id="uploadtag">';
			$ausgabe .= '<table class="ps" cellpadding="0" cellspacing="0" width="100%">';
			$ausgabe .= '<tr>';
			$ausgabe .= '	<td class="psh">Datei</td>';
			$ausgabe .= '	<td>';
			$ausgabe .= '		<input type="file" name="this_file" id="this_file" size="40" />';
			$ausgabe .= '	<td>';
			$ausgabe .= '</tr>';
			$ausgabe .= '<tr>';
			$ausgabe .= '	<td align="left" valign="top" class="psht">Beschreibung</td>';
			$ausgabe .= '	<td>';
			$ausgabe .= '		<textarea name="beschreibung" cols="40" rows="5" ></textarea>';
			$ausgabe .= '	<td>';
			$ausgabe .= '</tr>';
			$ausgabe .= '<tr>';
			$ausgabe .= '	<td class="psh">Kategorie</td>';
			$ausgabe .= '	<td>';
			$ausgabe .= '		'.$kategorie;
			$ausgabe .= '	<td>';
			$ausgabe .= '</tr>';
			$ausgabe .= '</table><br><input type="submit" name="send_file" value="Datei hochladen" />';
			if($upload_max_filesize!='')
				$ausgabe .= '<input type="hidden" name="MAX_FILE_SIZE" value="'.$upload_max_filesize.'" />';
			$ausgabe .= "</form></p>";
		}
		return $ausgabe;
	}
	/**
	 * Formatiert ein String zu ein Dateiname ohne Sonderzeichen
	 * @param string $string
	 * @return string
	 */
	function key_url($string){
		$string = rtrim($string);
		$umlaute = array(
	            '' => 'ae',
	            '' => 'ae',
	            '' => 'ss',
	            '&ouml;' => 'oe',
	            '' => 'oe',
	            '' => 'ue',
	            '' => 'ue',
				'-' => ',',
				' ' => ',',
	            '' => 'a',
	            '' => 'e',
	            '' => 'e',
	        );
	    $string = str_replace(array_keys($umlaute), array_values($umlaute), $string);
		$string = strtolower($string);
		$string = preg_replace('#[^a-z0-9,\.]#', '', $string);
		$string = substr(str_replace(",,", ",", $string),0,100);
		return $string ;
	}
	/**
	 * @return boolean
	 */
	function create_dir(){
		if($this->pfad!='' AND $this->newdir!=''){
			$dir=$this->pfad.'/bilder/'.$this->key_url($this->newdir);
			if(@is_dir($dir)===false)
				return @mkdir($dir, 0777);
			else
				return false;
		}
	}
	/**
	 * @return boolean
	 */
	function change_dir(){
		if($this->pfad!='' AND $this->newdir!='' AND $this->olddir!=''){
			$olddir=$this->pfad.'/bilder/'.$this->key_url($this->olddir);
			$newdir=$this->pfad.'/bilder/'.$this->key_url($this->newdir);
			if(@is_dir($olddir)==true)
				return @rename($olddir, $newdir);
			else
				return false;
		}
	}
	/**
	 * @return bool Returns true on success or false on failure
	 */
	function rmdir_dir() {
		if($this->rmdir_dir!=false)
			return(@rmdir($this->rmdir_dir));
    }
    /**
     * @return string
     */
	function _fileupload(){
		global $user_id,$dbh;
		if($_FILES['this_file']['size'] > $this->maxsize){
   			unset($_FILES['this_file']['tmp_name']);
  			$this->error(1, $_FILES['this_file']['size'] ." Bytes");
 		}
 		$i=0;
 		if(is_array($this->alowfile)!=false){
	 		foreach ($this->alowfile as $key => $value) {
	 			if($_FILES['this_file']['type'] == $value){
	        		$i++;
	 			}
	        }
 		}
 		if($i==0){
			unset($_FILES['this_file']['tmp_name']);
  			$this->error(2, $_FILES['this_file']['type']);
  		} else {
  			if($this->pfad==false) {
	 			$this->error(0, "Keine g&uuml;ltige Pfadangabe. ");
  			} else {
	 			/**
	 			 * Pr&uuml;fen ob Kategorie Eintrag gibt in der Datenbank
	 			 */
				$sql_select="SELECT kategorie_dir  FROM `kategorie` WHERE `id`='".$dbh->escape($this->kategorie_id)."' LIMIT 1;";
	            $sth = $dbh->prepare($sql_select, '-1');
	            $sth->execute();
	            $daten = $sth->fetchrow_hash();

	            $path_to_kategorie=$this->pfad.'/'.$daten['kategorie_dir'].'/';
	            /**
	 			  * Pr&uuml;fen ob den Kategorie Ordner auf den Server gibt
	 			  */
				if(@is_dir($path_to_kategorie)==false){
					$this->error(5, "Keine g&uuml;ltige Pfadangabe. Bitte pr&uuml;fen Sie ob ".$path_to_kategorie." ein Verzeichnis ist!");
				} else {
					$filename=$this->key_url($_FILES['this_file']['name']);
		 			$image_neu = $path_to_kategorie.$filename;

					/**
					 * Pr&uuml;fen ob es das Bild schon in der Datenbank gibt
					 */
					$sql_select="SELECT count(id) AS `anz` FROM `bilder` WHERE `dateiname` = '".$dbh->escape($filename)."' AND kategorie_id='".$dbh->escape($this->kategorie_id)."' LIMIT 1;";
		            $sth = $dbh->prepare($sql_select, '-1');
		            $sth->execute();
		            $daten = $sth->fetchrow_hash();
		            if(!isset($daten['anz'])) $anz=0; else $anz=$daten['anz'];
		            unset($daten);
		            $sth->finish();
		            $t=0;
					if($anz!=0){
						if(@file_exists($image_neu)==false){
							$sql_delete="DELETE FROM `bilder` WHERE `dateiname` = '".$dbh->escape($filename)."' AND kategorie_id='".$dbh->escape($this->kategorie_id)."' LIMIT 1;";
							$sth = $dbh->prepare($sql_delete);
		           			$sth->execute();
		            	} else {
							$this->error(4, "");
							$t=1;
						}
					}
					if($t==0) {
						if(decoct(fileperms($this->pfad))==40755 OR decoct(fileperms($this->pfad))==40777){
			 				if(@move_uploaded_file($_FILES['this_file']['tmp_name'], $image_neu)==true) {
			                    $sql_insert="INSERT INTO `bilder` (`dateiname`,`kategorie_id`,`timestamp`,`admin_id`, `beschreibung`) VALUES(
			                    		'".$dbh->escape($filename)."', '".$dbh->escape($this->kategorie_id)."','".time()."','".$user_id."','".$dbh->escape($this->beschreibung)."');";
			                    $sth = $dbh->prepare($sql_insert);
		                   		$sth->execute();
								unset($_FILES['this_file']);
								@chmod ($image_neu, 0755);
					  			return '1';
					 		} else {
					 			$this->error(0, "Keine g&uuml;ltige Pfadangabe oder keine Schreibrechte.");
							}
			 			} else {
			 				$this->error(3, "Der Upload Ordner hat keine Schreibrechte.");
			 			}
					}
				}
  			}
		}
	}
}
?>